Attribute VB_Name = "Module1"
'-----------------------------------------------------------------------
'       aisa15.bas
'
'       AISA-A15 Win32 API.
'-----------------------------------------------------------------------

Option Explicit

' őXbg
Global Const AISA15_MAX_SLOTS = 16

' _Xbgw
Global Const AISA15_SLOT_AUTO = &HFFFF

' G[R[h̒`
Global Const AISA15_ERR_INTERNAL = 5100              ' Send mail to us
Global Const AISA15_ERR_UNKNOWN = 5101               ' Help me!
Global Const AISA15_SUCCESS = 0                      ' I
Global Const AISA15_ERR_NO_DEVICE = 5000             ' No device or not an aISA-A15
Global Const AISA15_ERR_RESOURCE = 5001              ' Resource exhaustion
Global Const AISA15_ERR_INVALID_ARG = 5002           ' Invalid argument(s)
Global Const AISA15_ERR_SLOT = 5003                  ' _Xbgԍsłi܂͌܂j
Global Const AISA15_ERR_CHANNEL = 5004               ' `lw肪sł
Global Const AISA15_ERR_TIMER = 5005                 ' ^C}lsł
Global Const AISA15_ERR_DMA_BUFFSIZE = 5006          ' DMA]TCYsł
Global Const AISA15_ERR_NOT_ENOUGH_MEM = 5007        ' \ȃmۂł܂ł
Global Const AISA15_ERR_DMA = 5008                   ' DMA͎gpł܂
Global Const AISA15_ERR_NUMDATA = 5009               ' w肳ꂽ̃f[^obt@ɑ݂܂
Global Const AISA15_ERR_NOT_CREATED = 5010           ' foCXNGCgĂ܂
Global Const AISA15_ERR_START = 5011                 ' X^[gɎs܂
Global Const AISA15_ERR_INVALID_FUNC = 5012          ' Ȋ֐Ăяoł
Global Const AISA15_ERR_IN_USE = 5013                ' gp̃foCXł

' TvO[h̒`
                                            ' START  SAMPLING  TRANSFER  CLK
Global Const MODE_01 = 1                    ' soft   single    port      ---
Global Const MODE_02 = 2                    ' soft   single    port      EXTRG
Global Const MODE_03 = 3                    ' soft   burst     port      timer
Global Const MODE_04 = 4                    ' soft   burst     port      EXTRG
Global Const MODE_05 = 5                    ' soft   burst     DMA       timer
Global Const MODE_06 = 6                    ' EXIN0  single    port      ---
Global Const MODE_07 = 7                    ' EXIN0  single    port      EXTRG
Global Const MODE_08 = 8                    ' EXIN0  burst     port      timer
Global Const MODE_09 = 9                    ' EXIN0  burst     port      EXTRG
Global Const MODE_10 = 10                   ' EXIN0  burst     DMA       timer

' bZ[W
Global Const WM_EOC = 0                     ' VOTvO̊
Global Const WM_BUFF_HALF_FULL = 1          ' VxDOobt@̃n[tt
Global Const WM_BUFF_FULL = 2               ' VxDOobt@̃t
Global Const WM_BUFF_OVERFLOW = 3           ' VxDOobt@̃I[o[t[
Global Const WM_SAMPLING_OVERRUN = 4        ' `lEI[gECNg̃I[o[
Global Const WM_DMA_TC = 5                  ' DMA]

' ***** I/O\[X\ *****
' YfoCXgpI/O\[XAvP[V󂯎邽߂̍\́B
Type AISA15RESOURCE_NT
    dwIOPortBase As Long        ' I/O port base
    dwIRQRegisters As Long      ' IRQ list
    dwNumDMAs As Long           ' num DMA channels
    dwDMALst As Long            ' DMA list
End Type

' ***** TvO[h\ *****
' YfoCX̃TvO[hɊւsys֓n߂̍\́B
' iChFirstiChLast𓯂lɂ邱ƂŃ`lEI[gECNgȂ[hƂȂB
Type AISA15MODE
    iChFirst As Long   ' TvOJn`li0 - 15j
    iChLast As Long    ' TvOI`li0 - 15j
    cwBuffer As Long    ' obt@TCYi[hPʁj
    dwTimer As Long     ' ^C}ɃZbgli1`50000000)
    dwMode As Long      ' 샂[h(1`10)
End Type

' foCX̎gp錾
Public Declare Function Aisa15Create Lib "aisa15" (ByRef pwLogSlot As Integer, ByVal hwnd As Long, ByVal uWMBase As Long, pvInitArg As Any) As Long

' foCX̊J錾
Public Declare Function Aisa15Close Lib "aisa15" (ByVal wLogSlot As Integer) As Long

' foCXhCoDLL̃o[W擾
Public Declare Function Aisa15GetVersion Lib "aisa15" (ByRef pdwDllVer As Long, ByRef pdwDrvVer As Long) As Long

' I/O\[X̎擾
Public Declare Function Aisa15GetResource Lib "aisa15" (ByVal wLogSlot As Integer, ByRef pres As AISA15RESOURCE_NT) As Long

' TvO[h̐ݒ
Public Declare Function Aisa15SetMode Lib "aisa15" (ByVal wLogSlot As Integer, ByRef pcmode As AISA15MODE) As Long

' TvOJn
Public Declare Function Aisa15StartSampling Lib "aisa15" (ByVal wLogSlot As Integer) As Long

' TvO~
Public Declare Function Aisa15StopSampling Lib "aisa15" (ByVal wLogSlot As Integer) As Long

' TvOEXe[^X̎擾
Public Declare Function Aisa15GetSamplingStatus Lib "aisa15" (ByVal wLogSlot As Integer, ByRef pcwNumData As Long, ByRef pdwStatus As Long) As Long

' TvOς݃f[^̎擾
Public Declare Function Aisa15GetData Lib "aisa15" (ByVal wLogSlot As Integer, ByVal cwNumData As Long, ByRef pwData As Integer) As Long

' G[R[h̎擾
Public Declare Function Aisa15GetLastError Lib "aisa15" (ByVal wLogSlot As Integer) As Long

' O͏Ԃ̎擾
Public Declare Function Aisa15GetExIn Lib "aisa15" (ByVal wLogSlot As Integer, ByRef pdwExIn0 As Long, ByRef pdwExIn1 As Long, ByRef pdwExTrg As Long) As Long
