Attribute VB_Name = "aisa15w"
'*****************************************************************************
'* aisa15w.bas                                                               *
'*                                                                           *
'* aISA-A15                                                              *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'* Date 1998/04/21                                                           *
'*                                                                           *
'*****************************************************************************
Option Explicit
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const AISA15_DLL_NAME = "aisa15.dll" ' DLL

Dim hDLL As Long                'DLLւ̃nh

Global Const AISA15_ERR_WRAPDLL = -1  ' bp[֐G[

'*****************************************************************************
'*    aisa15.dll[h                                                 *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa15wDllOpen() As Boolean
    
    Aisa15wDllOpen = False

    If hDLL <> 0 Then Exit Function

    hDLL = LoadLibrary(AISA15_DLL_NAME)
    If hDLL = 0 Then Exit Function
    
    If Aisa15wGetDllExportFunc() = False Then
        Aisa15wDllClose     ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If

    Aisa15wDllOpen = True

End Function

'*****************************************************************************
'*    aisa15.dllA[h                                             *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa15wDllClose() As Boolean

    Aisa15wDllClose = True

    If hDLL = 0 Then Exit Function

    If FreeLibrary(hDLL) <> 0 Then hDLL = 0 Else Aisa15wDllClose = False

End Function

'*****************************************************************************
'*    aISA-A15 DLL,Driver̃o[Wԍ擾                           *
'*    pdwDllVer DLLo[Wԍi[                                  *
'*        pdwDrvVer Drivero[Wԍi[                               *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa15wGetVersion(pdwDllVer As Long, pdwDrvVer As Long) As Boolean
    
    Aisa15wGetVersion = False

    If hDLL = 0 Then Exit Function

    If Aisa15GetVersion(pdwDllVer, pdwDrvVer) = 0 Then Exit Function

    Aisa15wGetVersion = True

End Function

'*****************************************************************************
'*    aISA-A15̔Cӂ̃foCX̎gp錾                               *
'*    pwLogSlot gpfoCXi[AhX                       *
'*        hWnd      bZ[W𑗂EBhEnh                          *
'*        uWMBase   bZ[WID                                             *
'*        pvInitArg gp(0Zbg)                                        *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa15wCreate(pwLogSlot As Integer, hwnd As Long, uWMBase As Long, pvInitArg As Long) As Boolean

    Aisa15wCreate = False
    
    If hDLL = 0 Then Exit Function

    If Aisa15Create(pwLogSlot, hwnd, uWMBase, pvInitArg) = 0 Then Exit Function

    Aisa15wCreate = True

End Function

'*****************************************************************************
'*    aISA-A15̔Cӂ̃foCX̎gpJ                               *
'*    wLogSlot gpfoCX                                          *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa15wClose(wLogSlot As Integer) As Boolean

    Aisa15wClose = False

    If hDLL = 0 Then Exit Function

    If Aisa15Close(wLogSlot) = 0 Then Exit Function

    Aisa15wClose = True

End Function

'*****************************************************************************
'*    wfoCX̃\[X擾                                   *
'*    wLogSlot ׂfoCX                                            *
'*        pres     \[Xi[\                              *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa15wGetResource(wLogSlot As Integer, pres As AISA15RESOURCE_NT) As Boolean
    
    Aisa15wGetResource = False
    
    If hDLL = 0 Then Exit Function

    If Aisa15GetResource(wLogSlot, pres) = 0 Then Exit Function

    Aisa15wGetResource = True

End Function

'*****************************************************************************
'*    TvO[h̐ݒ                                           *
'*    wLogSlot ݒ肷foCX                                          *
'*        pcmode   [hݒf[^̃AhX                                *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa15wSetMode(wLogSlot As Integer, pcmode As AISA15MODE) As Boolean
    
    Aisa15wSetMode = False
    
    If hDLL = 0 Then Exit Function

    If Aisa15SetMode(wLogSlot, pcmode) = 0 Then Exit Function
        
    Aisa15wSetMode = True

End Function

'*****************************************************************************
'*    TvOJn                                                   *
'*    wLogSlot JnfoCX                                          *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa15wStartSampling(wLogSlot As Integer) As Boolean
    
    Aisa15wStartSampling = False
    
    If hDLL = 0 Then Exit Function

    If Aisa15StartSampling(wLogSlot) = 0 Then Exit Function
    
    Aisa15wStartSampling = True

End Function

'*****************************************************************************
'*    TvO~                                                   *
'*    wLogSlot ~foCX                                          *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa15wStopSampling(wLogSlot As Integer) As Boolean
    
    Aisa15wStopSampling = False
    
    If hDLL = 0 Then Exit Function

    If Aisa15StopSampling(wLogSlot) = 0 Then Exit Function
    
    Aisa15wStopSampling = True

End Function

'*****************************************************************************
'*    TvOEXe[^X̎擾                                     *
'*    wLogSlot   擾foCX                                        *
'*        pcwNumData f[^obt@                                        *
'*        pdwStatus  Xe[^X                                              *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa15wGetSamplingStatus(wLogSlot As Integer, pcwNumData As Long, pdwStatus As Long) As Boolean
    
    Aisa15wGetSamplingStatus = False
    
    If hDLL = 0 Then Exit Function

    If Aisa15GetSamplingStatus(wLogSlot, pcwNumData, pdwStatus) = 0 Then Exit Function
    
    Aisa15wGetSamplingStatus = True

End Function

'*****************************************************************************
'*    TvOς݃f[^̎擾                                       *
'*    wLogSlot  擾foCX                                         *
'*        cwNumData vf[^                                             *
'*        pwData    f[^obt@                                           *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa15wGetData(wLogSlot As Integer, cwNumData As Long, pwData() As Integer) As Boolean
    
    Aisa15wGetData = False
    
    If hDLL = 0 Then Exit Function

    If Aisa15GetData(wLogSlot, cwNumData, pwData(LBound(pwData))) = 0 Then Exit Function
    
    Aisa15wGetData = True

End Function

'*****************************************************************************
'*    O͏Ԃ̎擾                                                 *
'*    wLogSlot 擾foCX                                          *
'*        pdwExIn0 EXIN0̏                                               *
'*        pdwExIn1 EXIN1̏                                               *
'*        pdwExTrg EXTRG̏                                               *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa15wGetExIn(wLogSlot As Integer, pdwExIn0 As Long, pdwExIn1 As Long, pdwExTrg As Long) As Boolean
    
    Aisa15wGetExIn = False
    
    If hDLL = 0 Then Exit Function

    If Aisa15GetExIn(wLogSlot, pdwExIn0, pdwExIn1, pdwExTrg) = 0 Then Exit Function

    Aisa15wGetExIn = True

End Function

'*****************************************************************************
'*    aISA-A15̃G[R[h                                             *
'*    wLogSlot  G[foCX                                 *
'* ߂l G[R[h                                                       *
'*****************************************************************************
Function Aisa15wGetLastError(wLogSlot As Integer) As Long
    
    Aisa15wGetLastError = AISA15_ERR_WRAPDLL
    
    If hDLL = 0 Then Exit Function

    Aisa15wGetLastError = Aisa15GetLastError(wLogSlot)

End Function

'*---------------------------------------------------------------------------*
'*    DLLGNX|[g֐L̊mF                                      *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*---------------------------------------------------------------------------*
Private Function Aisa15wGetDllExportFunc() As Boolean

    Dim pFunc As Long
    
    Aisa15wGetDllExportFunc = False
    
    ' Aisa15GetVersion ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa15GetVersion")
    If pFunc = 0 Then Exit Function

    ' Aisa15Create ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa15Create")
    If pFunc = 0 Then Exit Function

    ' Aisa15Close ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa15Close")
    If pFunc = 0 Then Exit Function

    ' Aisa15GetResource ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa15GetResource")
    If pFunc = 0 Then Exit Function

    ' Aisa15SetMode ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa15SetMode")
    If pFunc = 0 Then Exit Function

    ' Aisa15StartSampling ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa15StartSampling")
    If pFunc = 0 Then Exit Function

    ' Aisa15StopSampling ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa15StopSampling")
    If pFunc = 0 Then Exit Function

    ' Aisa15GetSamplingStatus ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa15GetSamplingStatus")
    If pFunc = 0 Then Exit Function

    ' Aisa15GetData ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa15GetData")
    If pFunc = 0 Then Exit Function

    ' Aisa15GetExIn ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa15GetExIn")
    If pFunc = 0 Then Exit Function

    ' Aisa15GetLastError ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa15GetLastError")
    If pFunc = 0 Then Exit Function

    Aisa15wGetDllExportFunc = True  ' SĂ DLL GNX|[g֐݂̑mF

End Function

